/*
 * Copyright 2009-2010 Nanjing RedOrange ltd (http://www.red-orange.cn)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package redora.client;

/**
 * Value container for enum type fields. For each enum type field an java enum is created which implements this interface.
 * In runtime the values are in the by the user selected language.
 * @author Nanjing RedOrange (www.red-orange.cn)
 */
public interface EnumDisplay {
    /** @return  Header name for table view (i18n). */
    String displayTable();
    /** @return Field name for form view (i18n). */
    String displayForm();
    /** @return The name (no i18n). */
    String name();
}
